///////////////////////////////////////////////////////////////////////////////////
//	TIME-PILOT
//	Version 1.00 23-FEB-2004 
//	Autor: andreas.gross@ewetel.net
// (c) CENTURI SOFTWARE 2004 
///////////////////////////////////////////////////////////////////////////////////


///////////////////////////////////////////////////////////////////////////////////
// GameStudio main script
////////////////////////////////////////////////////////////////////////////
// Files to over-ride:
// * logodark.bmp - the engine logo, include your game title
// * horizon.pcx - A horizon map displayed over the sky and cloud maps
////////////////////////////////////////////////////////////////////////////
// The PATH keyword gives directories where game files can be found,
// relative to the level directory
path "C:\\PROGRAMME\\GSTUDIO6\\template";	// Path to WDL templates subdirectory

define SHOOTFREQ,skill33;  // wert gibt die verzgerung der Schuwiederholung an	
define SHOOTDELAY,skill34;// verzgerung beim schieen
define SHOOTVERT1,skill35; // Mndungspolygon
define SHOOTVERT2,skill36; // ggf. weiteres Mndungspolygon
define STAFFELPILOT,skill37;// Enthlt bei eiener Staffel die Flugzeugnummer
define BOMBENZEIT,skill37;// bekommt die Lebensdauer einer BOMBE/RAKETE		
define EXTRAZEIT,skill37;	// erhlt die Lebenszeit eines Extras
define EXTRA,skill38;		// EXTRA kann sein: PILOT, AMMO oder WUMME	
define BOMBVERT,skill40;
define _TYPE_ACTOR_SHOOT,96;
define _TYPE_PLAYER_SHOOT,97;
define _TYPE_BOMB,98;
define _TYPE_EXTRA,99;
define _EXTRA_PILOT,1;// Extra ist ein PILOT
define _EXTRA_AMMO,2;// Extra ist ein AMMO
define _EXTRA_WUMME,3;// Extra ist eine WUMME	
define _EXTRA_GAS,4;// Extra ist ein SPEEDUP	

string hub = <HUEYBODY.MDL>;// ACTOR 1970
string hubprop = <HUPROP.MDL>;//ACTOR'S 1970 PROPELLER  
string hubproph = <hutprop.MDL>;//ACTOR'S 1970 HECK-PROPELLER
string LGBODY =<LGBODY.MDL>;
string LGTPROP =<LGTPROP.MDL>;
string LGPROP1 =<LGPROP1.MDL>;
string LGPROP2 =<LGPROP2.MDL>;
string LGPROP3 =<LGPROP3.MDL>;
string LGPROP4 =<LGPROP4.MDL>;

string UFO =<UFO.MDL>;
string UFOBOSS =<UFOBOSS.MDL>;
string dd = <SCBODY.MDL>;// ACTOR 1916
string ddprop = <SCPROP.MDL>;//ACTOR'S 1916 PROPELLER  
string zeppelin = <ZEPPELIN.MDL>;//BOSS 1916
string STEALTH =<STEALTH.MDL>;
string MIG29 =<MIG29.MDL>;
string b52h = <b52h.mdl>;// ACTOR 1942
string thundblt = <thundblt.mdl>;// BOSS 1942
string f16 = <f16.mdl>;	// PLAYER
string bombe1916 = <bomb1916.mdl>;
string bombe1942 = <bomb1942.mdl>;
string bombe1970 = <bomb1970.mdl>;
string bombe1984 = <bomb1984.mdl>;
string bombe3000 = "";//<b3000.mdl>;
string bombestr = "              ";
string fallschirm = <falli.mdl>;
string pilot = <soldat.mdl>;
string mg = <mg.mdl>;
string ammo = <ammo.mdl>;
string gas = <propan.mdl>;
string dummy = <dummy.mdl>;
string pkt500 = <pkt500.bmp>;
//string blende = <schwarz.bmp>;

////////////////////////////////////////////////////////////////////////////
// The INCLUDE keyword can be used to include further WDL files,
// like those in the TEMPLATE subdirectory, with prefabricated actions
include <movement.wdl>;
include <messages.wdl>;
include <menu.wdl>;		// must be inserted before doors and weapons
include <particle.wdl>; // remove when you need no particles
include <doors.wdl>;		// remove when you need no doors
include <actors.wdl>;   // remove when you need no actors
//include <debug.wdl>;
include <weapons.wdl>;  // remove when you need no weapons
include <war.wdl>;      // remove when you need no fighting
//include <venture.wdl>;	// include when doing an adventure
include <lflare.wdl>;   // remove when you need no lens flares
include <score.wdl>;
include <preload.wdl>;

////////////////////////////////////////////////////////////////////////////
// The engine starts in the resolution given by the follwing vars.
var video_mode = 7;	 // screen size 640x480
var video_depth = 16; // 16 bit colour D3D mode

/////////////////////////////////////////////////////////////////
// Strings and filenames
// change this string to your own starting mission message.
//string mission_str = "TIMEPILOT 2003-2004 by Andreas Gross";
string level1916 = <lev1916.WMB>; // give file names in angular brackets
string level1942 = <lev1942.WMB>; 
string level1970 = <lev1970.WMB>; 
string level1984 = <lev1984.WMB>; 
string level3000 = <lev3000.WMB>; 
/////////////////////////////////////////////////////////////////
// define a splash screen with the required A4/A5 logo
bmap splashmap = <logo.pcx>; // the default logo in templates
panel splashscreen {
	bmap = splashmap;
	flags = refresh,d3d;
}

bmap titelmap = <titel.bmp>; // the default logo in templates
panel titelscreen {
	bmap = titelmap;
	flags = refresh,d3d;
}

bmap levelmap = <schwarz.bmp>; // the default logo in templates
panel levelscreen {
	bmap = levelmap;
	flags = refresh,d3d;
}

//Entity
//define BOSS,flag1;			// Flagge ist beim BOSS (Actor) gesetzt

entity* dummy_ent;
entity* BOSS;
entity* blende_ent;

function bombenstrahl();
function 1942_bossduesen();
function bullet_shot();
function alphafade();
function alphafadein();
function MCP();
function nextLevel();
function nextAD();
function	attach_prop_entity();
function 3000_ufoanim();
function* bossfnk;
function* staffnk;
function* fliegfnk;
function laser_shot();
function bugcheck();
//string point = <point.mdl>;
var	PlanesNr;		// Anzahl der sich im Spiel befindlichen Flugzeuge
var 	pilotNr;			// Anzahl der zur Staffel gehrenden Flugzeuge im Spiel	
var 	BombenNr;	
var 	tempvec[3];
var 	maxbomb;	// Maximale Anzahl Bomben im Spiel 
var 	bombforce = 1; // Standartgeschw. der BOMBE, je Level unterschiedlich
var 	bomblifespan = 150;// Lebensdauer der Bombe
var	bombwait;	// Wartezeit zwische zwei Bomben
var 	pktvec[3];		// Fr die Positionierung der Punkteanzeige 500 
var	levelnr;			// 1916, 1942, 1970, 1984, 3000
var	ticks[2];		// Ticks zur Zeitmessung
var	BugSim;			// Tuscht einen Fehler beim Debuggen vor
var	squad;
var 	Levelende;		// Wenn der BOSS abgeschossen wurde
//var	game_running;
var	paused;

sound mg1wav = <mg1.wav>;
sound propwav = <prop.wav>;
sound bombwav = <rakete.wav>;
sound staffel = <ALARM.WAV>;
sound bonus = <BUNUSPKT.WAV>;
sound levelstart =<LEVSTRT.WAV>;
sound LEVELEND =<LEVEND.WAV>;
sound INTRO = <INTRO1.WAV>;
sound ddwav = <DOPPELD.WAV>;
sound HUBwav = <HUBSCHR.WAV>;
sound JETWAV = <JET.WAV>;
sound ufowav = <SPACE.WAV>;
sound LASERWAV =<UFOLASER.WAV>;
sound ufobosswav = <UFOBOSS.WAV>;
/////////////////////////////////////////////////////////////////
// The main() function is started at game start
function main()
{
// set some common flags and variables
//	warn_level = 2;	// announce bad texture sizes and bad wdl code
	tex_share = on;	// map entities share their textures
//	fps_max = 60;


// center the splash screen for non-640x480 resolutions, and display it
	splashscreen.pos_x = (screen_size.x - bmap_width(splashmap))/2;
	splashscreen.pos_y = (screen_size.y - bmap_height(splashmap))/2;
	splashscreen.visible = on;
// wait 3 frames (for triple buffering) until it is flipped to the foreground
	wait(3);

	// Keinen Mauszeiger darstellen
	MOUSE_MAP = NULL;
	MOUSE_MODE = 0;

// now load the level
//	level_load(level1942);
// freeze the game
	freeze_mode = 1;

// wait the required second, then switch the splashscreen off.
	sleep(1);
	
  	splashscreen.visible = off;
	bmap_purge(splashmap);	// remove splashscreen from video memory

// load some global variables, like sound volume


// display the initial message
//	msg_show(mission_str,10);

// initialize lens flares when edition supports flares
ifdef CAPS_FLARE;
	lensflare_start();
endif;

// use the new 3rd person camera
	move_view_cap = 1;

// un-freeze the game
	freeze_mode = 0;

//	client_move();	// for a possible multiplayer game
// call further functions here...
 
//	exec("intro", null);
// Spiele Musik ribanna.mid mit halber maximaler Lautstrke endlos ab.
// handle = media_loop("ribanna.mid",null,50);
// Spiele Film news.avi auf Textur der Entity tv_model mit maximaler Lautstrke
 //	media_play("tm.avi",splashscreen,50);

//	debugon();

	// Grafik in den Videospeicher laden (ruckeln im Spiel vermeiden)

	mainscreen();
}

/////////////////////////////////////////////////////////////////
// The following definitions are for the pro edition window composer
// to define the start and exit window of the application.
WINDOW WINSTART
{
	TITLE			"TimePilot";
	SIZE			480,320;
	MODE			IMAGE;	//STANDARD;
	BG_COLOR		RGB(80,0,0);
	SET_FONT		"Arial",RGB(200,200,0);
	TEXT			"TIME PILOT\n(c) CENTURI SOFTWARE 2004"
	FRAME			FTYP1,0,0,480,320;
	PICTURE 		"PYRAMIDS.JPG", opaque, 10, 10;
//	BUTTON		BUTTON_START,SYS_DEFAULT,"Start",400,288,72,24;
	BUTTON		BUTTON_QUIT,SYS_DEFAULT,"Abort",400,288,72,24;
	TEXT_STDOUT	"Arial",RGB(0,0,0),10,10,460,280;
	PROGRESS		RGB(200,200,0),50,10,300,460,16;
}

/* no exit window at all..
WINDOW WINEND
{
	TITLE			"Finished";
	SIZE			540,320;
	MODE	 		STANDARD;
	BG_COLOR		RGB(0,0,0);
	TEXT_STDOUT	"",RGB(255,40,40),10,20,520,270;

	SET FONT		"",RGB(0,255,255);
	TEXT			"Any key to exit",10,270;
}*/


/////////////////////////////////////////////////////////////////
//INCLUDE <debug.wdl>;

define WOLKE_XMAX,500;// innerhalb dieses Bereiches bewegen sich die Wolken
define WOLKE_YMAX,500;
define WOLKE_XMIN,-500;
define WOLKE_YMIN,-500;

var pos_x;				 // Bewegungsrichtung des Spielfeldes
var pos_y;

action saubereWolke
{
	my.passable = on;	
	my.transparent = on;
	my.alpha = 50+random(20);
	my.pan = random(360);
	temp = random(0.5)+0.75;
	my.scale_x=temp; my.scale_y=temp;

	while(1)
	{
		me.x += pos_x;		
		if (pos_x<0) {
			if (me.x<WOLKE_XMIN) { me.x = WOLKE_XMAX; }
		} else {
			if (me.x>WOLKE_XMAX) { me.x = WOLKE_XMIN; }
		}
		me.y += pos_y;		
		if (pos_y<0) {
			if (me.y<WOLKE_YMIN) { me.y = WOLKE_YMAX; }
		} else {
			if (me.y>WOLKE_YMAX) { me.y = WOLKE_YMIN; }
		}										
		wait(1);
	}
	//ent_remove(me);
	//while(me){alphafade();}
}

action schmutzigeWolke
{
	my.passable = on;	
	my.transparent = on;
	my.alpha = 85+random(15);
	my.pan = random(360);
	temp = random(0.5)+0.5;
	my.scale_x=temp; my.scale_y=temp;

	while(1)
	{
		me.x += pos_x;		
		if (pos_x<0) {
			if (me.x<WOLKE_XMIN) { me.x = WOLKE_XMAX; }
		} else {
			if (me.x>WOLKE_XMAX) { me.x = WOLKE_XMIN; }
		}
		me.y += pos_y;		
		if (pos_y<0) {
			if (me.y<WOLKE_YMIN) { me.y = WOLKE_YMAX; }
		} else {
			if (me.y>WOLKE_YMAX) { me.y = WOLKE_YMIN; }
		}					
		wait(1);
	}
	//ent_remove(me);
	//while(me){alphafade();}	
}

function player_event()
{
	//printi("PLAYER-EVENT",1);db1+=10;
	if (YOU._TYPE == _TYPE_ACTOR_SHOOT){
		MY._HEALTH-=20;
		if(playerNr){
			life_set(lifes2, my._health);
		} else {
			life_set(lifes1, my._health);
		}
	}
	// Kollison mit einer gegnerischen Maschine, 	
	if (YOU._TYPE == _TYPE_ACTOR){
		MY._HEALTH-=random(2);// max. die hlfte der Gesundheit nehmen
//db6+=1;	
		if(MY._HEALTH<0){MY._HEALTH=0;}// fr die Anzeige
		if(playerNr){// Anzeige aktualisieren
			life_set(lifes2, my._health);
		} else {
			life_set(lifes1, my._health);
		}
	}
	if (YOU._TYPE == _TYPE_BOMB){
		MY._HEALTH-=75;
		if(MY._HEALTH<0){MY._HEALTH=0;}
		if(playerNr){
			life_set(lifes2, my._health);
		} else {
			life_set(lifes1, my._health);
		}	
	}

	if (YOU._TYPE == _TYPE_EXTRA){
		if (YOU.EXTRA==_EXTRA_WUMME) { 
			if (MY.SHOOTVERT2>0) {
				MY.SHOOTFREQ=1;// superschnelles MG
			} else {
				ME.SHOOTVERT1 = 53;
				ME.SHOOTVERT2 = 481; 
			}
		}
		if (YOU.EXTRA==_EXTRA_PILOT) { 
			life_add(); 
		}
		if (YOU.EXTRA==_EXTRA_AMMO) { 
			MY._HEALTH += 75+random(25);
			if(playerNr){
				life_set(lifes2, my._health);
			} else {
				life_set(lifes1, my._health);
			}
		}
		if (YOU.EXTRA==_EXTRA_GAS) { 
			if (MY._SPEED<3){
				MY._SPEED += 0.250;
				MY._ASPEED += 0.250;
			} 
		}
			YOU.PASSABLE = ON;
			PROC_KILL(2);
			WAIT(1);
			ENT_REMOVE(YOU);// DUMMY-KUGEL
	}

	if (MY._HEALTH<=0) {
		PROC_KILL(1);	// terminate other actions, to stop moving
		wait(1);// added to avoid Dangerous instruction
		MY.EVENT = NULL;
		morph BULLET_EXPLO,ME;
		my.scale_x=1;my.scale_y=1;
		MY._DIEFRAMES = EXPLO_FRAMES;
		actor_explode();
		life_sub();
		// Spieler ggf. wechseln
		if(playerAnz==2){
			playerNr = 1 - playerNr;
		} 
	}
}


var mymove[3] = 0.001, 0.000, 0.000;
action PlayerTop
{
	
	PLAYER = ME;
	if (levelNr==1916){
		ENT_PLAYLOOP( ME,ddwav,300);// Machmal fllt der Motorensound aus
	} else {
		if (levelNr==1942){
			ENT_PLAYLOOP( ME,propwav,200);// Machmal fllt der Motorensound aus
		} else {
			if (levelNr==1970){
				ENT_PLAYLOOP( ME,hubwav,250);// Machmal fllt der Motorensound aus
			} else {
				if (levelNr==1984){
					ENT_PLAYLOOP( ME,jetwav,300);// Machmal fllt der Motorensound aus
				} else {
					if (levelNr==3000){
						ENT_PLAYLOOP( ME,ufowav,300);// Machmal fllt der Motorensound aus
					}
				}
			}
		}
	}

	var salve;// Feuerunterbrechung fr den Player
	var fireTimeOut;
	var coldkey;
	
	while(ME)
	{

		// Drehung 
//my.pan += key_force.x * time; 
		if (key_cur==1 || joy_force.x>0 ) {

			if (me.pan>0) {
				me.pan -= me._ASPEED;
			} else {
				me.pan = 359;
			}		
			if (camera.pan>0) {
				camera.pan -= 0.25;
			} else {
				camera.pan = 359.75;
			}
		}
		if (key_cul==1 || joy_force.x<0 ) {

			if (me.pan<359) {
				me.pan += me._ASPEED;
			} else {
				me.pan = 0;
			}
			if (camera.pan<359.75) {
				camera.pan += 0.25;
			} else {
				camera.pan = 0;
			}
		}
		// Schieen
		temp = key_space + joy_1;// Status von Spacetaste und Joysticktaste
		if(temp==0 && salve==0){//Registrien, wenn die Taste losgelassen wurde 
			coldkey=0;
		}
		if(temp && salve==0 && coldkey==0){// Feuerstoss einleiten
			coldkey=1;
			salve=5;
		}
		if(salve && total_ticks >= fireTimeOut){// Feuern, wenn verzgerung berschritten
			FireTimeOut=total_ticks+2;
			salve-=1;
			schuss(_TYPE_PLAYER_SHOOT);
		}		
/*
		//if(temp==0){feuerstop=0;};
		if(temp && total_ticks > feuerverz && feuerstop==0) {
			feuerstoss+=1;
//db6=feuerstoss;
			schuss(_TYPE_PLAYER_SHOOT);
			if (feuerstoss>=40){
				feuerstop=1; 
				feuerstoss=0;
				feuerverz=total_ticks+7;
			}
			//}	
		}

*/
/*
		// Falls Keine Aktion von Spieler erfolgte
		if (aktion == 0 & my.pan!=0) {
			db3=my.pan;
			if (me.pan<180) {if (my.pan>0) {me.pan-=me._ASPEED;} } 
			else {if (my.pan<359) {my.pan+=me._ASPEED;} }			
		}
*/
		me.roll = sin(me.pan/2)*90;// zur (unrealistischen) Seitenansicht drehen	

		// Bewegung
 	//if (key_cuu==1){
		//move_mode = IGNORE_YOU + IGNORE_PASSABLE + IGNORE_PUSH + ACTIVATE_TRIGGER; 
		//ent_move(nullvector, nullvector);
		pos_x = -cos(me.pan) * me._SPEED;	
 		pos_y = -sin(me.pan) * me._SPEED;

	//}else {pos_x=0;pos_y=0;}
//db4=me.z;
//displABC();
// PLAYER mu zur kollisonserkennung (minimal) bewegt werden
if (mymove>0){mymove=-mymove;} else {mymove=abs(mymove);}
move_mode = IGNORE_PASSABLE + IGNORE_PASSENTS + IGNORE_MAPS + IGNORE_SPRITES ;
ent_move(mymove,mymove);
//db4=my.x*1000;
//db5=my.y*1000;
//db6=my.z*1000;

		// Dsenstrahl
		vec_for_vertex(temp, my, 268);
		tempvec.x=-3;tempvec.y=0;tempvec.z=0;
		vec_rotate(tempvec, player.pan); 
		effect(bombenstrahl,1,temp,tempvec);
	
		if (playerAnz==0) {alphafade();}
		wait(1);
	}
}

//DEFINE PLAIN_EXPLO,<explo3+16.pcx>;
function actor_event()
{
	//db9+=1;
	if (YOU._TYPE == _TYPE_EXTRA){ RETURN; }
	// kein Zusammenstoss mit anderen Maschinen auer dem Player
	if (YOU._TYPE == _TYPE_ACTOR){ RETURN; }
	// Zusammenstoss mit eigenem oder freundlichem Feuer vermeiden
	if (YOU._TYPE == _TYPE_ACTOR_SHOOT){ 
		YOU._MOVEMODE = 0;
		YOU.EVENT = NULL;
		PROC_KILL(2);// alle aktionen der von YOU lschen
		wait(1);// added to avoid Dangerous instruction
		REMOVE(YOU);
		RETURN; 
	}
	// getroffen vom ACTOR
	if (YOU._TYPE == _TYPE_PLAYER_SHOOT){MY._HEALTH-=20;}
	// zusammenstoss mit dem PLAYER, sofort explodieren
	if (YOU._TYPE == _TYPE_PLAYER){
		if(MY==BOSS){
			my._health-=2;
		} else {// bei normalen maschinen
			MY._HEALTH-=100;
		}
	}

//	printi("ACTOR-EVENT",2);db3=my._health;
	if (MY._HEALTH<=0) {
		MY.EVENT = NULL;
		proc_kill(1);	// terminate other actions, to stop moving
		wait(1);// added to avoid Dangerous instruction
		// wenn die Maschine zu einer Staffel gehr
		if (my.STAFFELPILOT>0){
			PilotNr-=1;
			if (PilotNr==0 && squad) {
				squad=0; 
				vec_set(pktvec,me.pos);
				punkte500(); 
			}
		} 
		// Falls der Boss abgeschossen wurde
		if (MY==BOSS){
			LevelEnde=1;
			score_add(3000);
		} else {	
		//	db8=pilotnr;
		//	db9=planesnr;
			score_add(100);
		}

		morph BULLET_EXPLO,ME;
		my.scale_x=1;my.scale_y=1;
		MY._DIEFRAMES = EXPLO_FRAMES;
		actor_explode();
		PlanesNr-=1;
	}
}

//var minvec[3] = 100,0,0;
define _TARGET_TIME, skill40;
function neuesZiel(max_radius)
{	
	var atvec[3];
	my._TARGET_X = random(max_radius);
	my._TARGET_Y = random(max_radius);
	my._TARGET_Z = 0;
	atvec = random(360);
	vec_rotate(my._TARGET_X, atvec); 		

	my._TARGET_TIME = 400 + random(100);// Dauer, in der dieses Ziel angeflogen wird 
}

function startPos()
{
	my.x = 350;
	my.y = 0;
	my.z = 0;
	tempvec.pan = random(360);
	tempvec.tilt = 0;
	tempvec.roll = 0;
	vec_rotate(my.x, tempvec);
}



// regelt das Flugverhalten (Angriff, Punkt ansteuern) aller Maschinen
function flug()
{
	// falls eine Maschine nicht vollstndig initialisiert ist
	actor_init();
	
//	startpos();
	neuesZiel(150);
	while(ME){
		planemove();
		// find direction
		temp.x = MY._TARGET_X - MY.X;
		temp.y = MY._TARGET_Y - MY.Y;
		temp.z = 0;
		result = vec_to_angle(my_angle,temp);
//db1=vec_length(my.x);	
//db2=result;
		my._TARGET_TIME-=1;
//db2=my.skill40;
//db8=my.z;
		force = MY._FORCE;

		// compare radius must exceed the turning cycle!
		if (result < 50 || my._TARGET_TIME<=0) {
			// Feind zu weit abgetrieben, neuer Angriff 
			if (vec_length(my.x)>500){Startpos();}	
			// wechselweise annhren und entfernen
			temp = 500 - vec_length(my.x);
			if (temp<100){temp+=100;}
			neuesZiel(temp);	
		}
	/* WAS IST, WENN DER VECTOR ZU LANG WIRD??? */

		// turn and walk towards target
		actor_turnto(my_angle.PAN);
		my.z=0;
		actor_move();
		my.z=0;
		// AKTION abbrechen, wenn PLAYER zerstrt ist oder 
		// das Spiel mittels ESCAPE abgebrochen wird.
		if (PLAYER==NULL || playerAnz==0) {alphafade();}
		wait(1);	
	}
}

// Flugzeug-Pfad relativ zur Spielsteuerung bewegen
function planemove()
{
	my.x += pos_x;
	my.y += pos_y;

}
	
///////////////////////////////////////////////////////////////////////
// helper actions

// Desc: initialize a walking actor
function actor_init()
{
	if (my._FORCE == 0) {  my._FORCE = 1; }
	if (my._MOVEMODE == 0) { my._MOVEMODE = _MODE_PLANE; }
	if (my._WALKFRAMES == 0) { my._WALKFRAMES = 1; }
	if (my._WALKSOUND == 0) { my._WALKSOUND = _SOUND_WALKER; }
	anim_init();
}

// Desc: turn towards a destination angle
// force must be set to 0.5..5
function actor_turnto(angle)
{
	angle = ang(angle - MY.PAN);

	if (angle > 10)
	{
		temp = force * 5;
	}
	else
	{
		if(angle < -10)
		{
			temp = -force * 5;
		}
		else
		{
			temp = force * angle * 0.5;
		}
	}

// Now change MY angles
	MY.PAN += temp * min(1,time) /* /2 */ ;
	MY.ROLL = sin(MY.PAN/2)*90;// zur (unrealistischen) Seitenansicht drehen	

}

// Desc: move ahead, according to force.X
//
//]- Mod Date: 7/5/00 by DCP
//]-				Changed to function
function actor_move()
{
	force.Y = 0;
	force.Z = 0;
	MY.Z = 0;
	// find ground below
	scan_floor();
	move_gravity();
	MY.Z = 0;
	actor_anim();
}

// 
function ende()
{ 
	while(key_esc==1){wait(1);}
	if (playerAnz){playerAnz=0;}
	else {exit;}
}
on_esc = ende;

function alphafade()
{
//	while(my.alpha > 0){
		my.transparent=on;
		my.alpha -= time*5;
//		wait(1);
//	}
	if (my.alpha <= 0){
		if (my._TYPE==_TYPE_ACTOR) {
			if (my.STAFFELPILOT >0) {pilotnr-=1;}
			planesnr-=1;
		}

		if (my._TYPE==_TYPE_BOMB) {bombennr-=1;}
		proc_kill(1);
		wait(1);
		//if (my._TYPE==_TYPE_PLAYER) {PLAYER==0;}
//		if (my.BOSS==ON){Boss = 0;}
		ent_remove(me);
	}
}
function alphafadein()
{
	my.transparent=on;
	my.alpha=0;
	while(my.alpha < 100){
		my.alpha += time*8;
		wait(1);
	}
	my.transparent=off;
}



// Hilfsfunktion: blendet einen Partikel aus
function part_alphafade()
{
  my.alpha -= time/*+time*/;
  if (my.alpha <= 0) { my.lifespan = 0; } // Alpha <= 0, dann Partikel vernichten
}

//Partikelfunktion: generiert eine verblassende Explosion in Richtung vel 
function bombenstrahl()
{
	my.alpha = 25 + random(25);
	my.bmap = scatter_map;
	my.flare = on;
	my.bright = on;
	my.beam = on;
	my.move = on;
	my.function = part_alphafade; // ndere in eine krzere, schnellerer Funktion
}


function bombe();

function bombe_event()
{
	if(YOU){
		if (YOU._TYPE == _TYPE_BOMB){RETURN;}
		if (YOU._TYPE == _TYPE_ACTOR){RETURN;}
		if (YOU._TYPE == _TYPE_ACTOR_SHOOT){RETURN;}
		if (YOU._TYPE==_TYPE_PLAYER_SHOOT){score_add(100);}
	}
	MY._MOVEMODE = 0;
	MY.EVENT = 0;
	proc_kill(1);
	wait(1);
	morph BULLET_EXPLO,ME;
	MY._DIEFRAMES = EXPLO_FRAMES;
	actor_explode();
	BombenNr-=1;
}

function bombe_init()
{
//return;	
	if (bombennr>=maxbomb || levelNr==3000){return;}
	bombennr+=1;
	vec_for_vertex(temp, my, my.BOMBVERT);
	temp.z=0;
	temp_ent = ent_create (bombestr, temp, bombe);
	//	wait(1);
	TEMP_ENT.ENABLE_IMPACT = ON; 
	TEMP_ENT.ENABLE_ENTITY = ON;
	TEMP_ENT.EVENT = BOMBE_EVENT;
	PLAY_ENTSOUND ME,bombwav,200;
	temp_ent._TYPE = _TYPE_BOMB;// abgeschossen von PLAYER oder ACTOR
	temp_ent.scale_x=0.3; temp_ent.scale_y=0.3; temp_ent.scale_z=0.3;
}
// Bombe fliegt automatisch zum TARGET: PLAYER.POS=(0,0,0)
//define LEBENSSPANNE,SHOOTFREQ;
function bombe()
{
	my._force=bombforce;
	actor_init();

//	randomize();
	my.BOMBENZEIT = bomblifespan+random(100);
  	
	// 	 my.SHOOTDELAY = int(total_ticks/my.SHOOTFREQ);//schuverzgerung
	while(MY._MOVEMODE){
//score2=bombforce*1000;//my._force;
//db5=my.BOMBENZEIT;
		my.BOMBENZEIT-=time;
		// auf den PLAYER zusteuern, solange die Entfernung gro ist
		if (my.BOMBENZEIT>0){
			if (vec_length(my.x) > (random(100))){ 
				vec_set(temp,nullvector); 
				vec_sub(temp,my.x);
				vec_to_angle(tempvec,temp); 
			}
		}
		planemove();
		force = MY._FORCE;
		actor_turnto(tempvec.pan);
		actor_move();
		my.z=0;
//db8=me;
//db9=vec_length(my.x);
		vec_for_vertex(temp, my, 1);
		tempvec.x=-2;tempvec.y=0;tempvec.z=0;
		vec_rotate(tempvec, my.pan); 
		effect(bombenstrahl,1,temp,tempvec);

	//	bombenstrahl(temp);
		// Ausserhalb des Sichtbereiches?
		if (vec_length(my.x)>300){
			ent_remove(me);	
			BombenNr-=1;	
			break;			
		}
		if (PLAYER==0){alphafade();}
		wait(1);
	}//WHILE(1)
}

//on_b = bombe_init;

string shotmap = <blitz.pcx>;
//entity* ent;
function schuss(von)
{

	if (my.SHOOTFREQ==0) {my.SHOOTFREQ=5;}
  	if (my.SHOOTDELAY < int(total_ticks/my.SHOOTFREQ)) {
	 	 my.SHOOTDELAY = int(total_ticks/my.SHOOTFREQ);//schuverzgerung
//db7+=1;
		actor_scale.x=0.2;

		damage=10; 
		shot_speed.x = 30; 
		shot_speed.y=0; 
   	shot_speed.z=0;

		
		vec_set(MY_ANGLE.PAN, MY.PAN);
		vec_rotate(SHOT_SPEED, MY_ANGLE);
		
		fire_mode = FIRE_BALL + DAMAGE_SHOOT;

		
		vec_for_vertex(temp, my, my.SHOOTVERT1);
		//vec_scale(temp, 1.500);
		if(levelNr==3000 && ME!=PLAYER){
			temp_ent = ent_create (shotmap, temp, laser_shot);
			PLAY_ENTSOUND ME,laserwav,250;
		} else {
			temp_ent = ent_create (shotmap, temp, bullet_shot);
			PLAY_ENTSOUND ME,mg1wav,150;
		}
		temp_ent._TYPE = von;// abgeschossen von PLAYER oder ACTOR

		if(my.SHOOTVERT2>0){
			vec_for_vertex(temp, my, my.SHOOTVERT2); 
		//	vec_scale(temp, 1.500);
			if(levelNr==3000 && ME!=PLAYER){
				temp_ent = ent_create (shotmap, temp, laser_shot);
				//PLAY_ENTSOUND ME,laserwav,250;
			} else {
				temp_ent = ent_create (shotmap, temp, bullet_shot);
				//PLAY_ENTSOUND ME,mg1wav,150;
			}
			temp_ent._TYPE = von;// abgeschossen von PLAYER oder ACTOR
		}
  	} 
}

// Programmpanel (pp)

TEXT pp
{
	POS_X 100;
	POS_Y 450;
	FONT	big_font;
	STRINGS 12;
	STRING "                                        ";
	STRING "                                        ";
	STRING "                                        ";
	STRING "                                        ";
	STRING "                                        ";
	STRING "                                        ";
	STRING "                                        ";
	STRING "                                        ";
	STRING "                                        ";
	STRING "                                        ";
	STRING "                                        ";
	STRING "                                        ";
}

function gameOver()
{
	pp.pos_x = 200; pp.pos_y = 250;
	pp.string = "G A M E  O V E R";
	pp.visible = on;
}
function gamePaused()
{
	pp.pos_x = 250; pp.pos_y = 250;
	pp.string = "P A U S E";
	pp.visible = on;
}
//on_g = gameover;

function InputName
{
	pp.POS_X = 100; pp.POS_Y = 450;
	pp.STRING = "ABCDEFGHIJKLMNOPQRSTUVWXYZ";
	pp.visible = ON;
}

var bombTimeStop=500;
// bergabe:	50=NORMAL hufigkeit des Feuerns, 0=IMMER 1000=FAST NIE
function feuertest()
{
	var salve;


	ME.ENABLE_IMPACT = ON; 
	ME.ENABLE_ENTITY = ON;
	ME.EVENT = ACTOR_EVENT;
	randomize();
	
	while(my) {
	// hole die Richtung von der Entity MY zur Entity YOU
		if (player){

			// MG-Reichweite berprfen
			vec_set(temp,player.x); 
			vec_sub(temp,my.x);
			vec_to_angle(tempvec,temp); 
			temp=ang(int(tempvec.pan-ang(my.pan)));
			// Schieen mit Abweichung von +-20, entfernung wird nicht bercksichtigt
			if (MY==BOSS){result=80;} else {result=20;}// der BOSS schiet im greren Winkel
			if (temp>=-result && temp<=result && salve==0) {
				if(levelNr==3000){
					if (int(random(5))==1) {salve = 1;}			
				} else {
					if (my.STAFFELPILOT>0){
						if (int(random(200))==1) {salve = 2;}		
					} else {
						if (int(random(150))==1) {salve = 3;}			
					}
				}
			}
			if (salve){
				schuss(_TYPE_ACTOR_SHOOT);
				salve-=1;
			}
//db7=total_ticks;
//db6=bombtimestop;
			// BOMBEN-Reichweite berprfen
			if (vec_length(my.x)<275 && total_ticks > bombTimeStop){
				bombTimeStop=total_ticks + bombwait + random(200);

				bombe_init();
			}
		}
		wait(1);
	}
}

function 1942_boss()
{
	planesnr+=1;
	temp.x=0;temp.y=400;temp.z=0;
	me = ent_create(thundblt, temp, flug );
	BOSS = ME;
	me.scale_x=0.2; me.scale_y=0.2; me.scale_z=0.2;// Gre der Kaschine sicherstellen
	wait(1);// zeit geben, die Entity zu erstellen
	MY.TRANSPARENT = OFF;
	1942_bossduesen();// Dsenstrahlen
	feuertest();// schiessen, wenn PLAYER im Fadenkreuz ist.
	ME.SHOOTVERT1 = 247;// bei thundblt, schiest unterh. der Tragfl.
	ME.SHOOTVERT2 = 251;
	MY.BOMBVERT = 175;// von hier wird die BOMBE gestartet
	ME._HEALTH = 500;// mod. Schwierigkeit: Leicht, mittel, schwer 
	ME._TYPE = _TYPE_ACTOR;
	ME.SHOOTFREQ=3;// norm. MG
	ME.TRANSPARENT = OFF;
	maxbomb = 2;// Soviel RAKETEN sind im Spiel
	bombwait=100;//wartezeit zwischen zwei BOMBEN
	ME._FORCE = 0.55 + random(0.2);
	ENT_PLAYLOOP( ME,propwav,500);
}
function 1970_boss()
{
	planesnr+=1;
	temp.x=0;temp.y=400;temp.z=0;
	me = ent_create(lgbody, temp, flug );
	BOSS = ME;
	me.scale_x=1; me.scale_y=1; me.scale_z=1;// Gre der Kaschine sicherstellen
	wait(1);// zeit geben, die Entity zu erstellen
	MY.TRANSPARENT = OFF;
	feuertest();// schiessen, wenn PLAYER im Fadenkreuz ist.
	ME.SHOOTVERT1 = 166;// bei thundblt, schiest unterh. der Tragfl.
	ME.SHOOTVERT2 = 246;
	MY.BOMBVERT = 430;// von hier wird die BOMBE gestartet
	ME._HEALTH = 500;// mod. Schwierigkeit: Leicht, mittel, schwer 
	ME._TYPE = _TYPE_ACTOR;
	ME.SHOOTFREQ=3;// norm. MG
	ME.TRANSPARENT = OFF;
	ent_create(lgtprop, nullvector, attach_prop_entity );
	ent_create(lgprop1, nullvector, attach_prop_entity );
	ent_create(lgprop2, nullvector, attach_prop_entity );
	ent_create(lgprop3, nullvector, attach_prop_entity );
	ent_create(lgprop4, nullvector, attach_prop_entity );
	maxbomb = 2;// Soviel RAKETEN sind im Spiel
	bombwait=100;//wartezeit zwischen zwei BOMBEN
	ME._FORCE = 0.65 + random(0.2);
	ENT_PLAYLOOP( ME,hubwav,800);
}

function 1984_boss()
{
	planesnr+=1;
	temp.x=0;temp.y=400;temp.z=0;
	me = ent_create(stealth, temp, flug );
	BOSS = ME;
	me.scale_x=1; me.scale_y=1; me.scale_z=1;// Gre der Kaschine sicherstellen
	wait(1);// zeit geben, die Entity zu erstellen
	MY.TRANSPARENT = OFF;
	feuertest();// schiessen, wenn PLAYER im Fadenkreuz ist.
	ME.SHOOTVERT1 = 52;// bei thundblt, schiest unterh. der Tragfl.
	ME.SHOOTVERT2 = 255;
	MY.BOMBVERT = 144;// von hier wird die BOMBE gestartet
	ME._HEALTH = 500;// mod. Schwierigkeit: Leicht, mittel, schwer 
	ME._TYPE = _TYPE_ACTOR;
	ME.SHOOTFREQ=2;// schnelles MG
	ME.TRANSPARENT = OFF;
	1984_bossduesen();
	maxbomb = 2;// Soviel RAKETEN sind im Spiel
	bombwait=100;//wartezeit zwischen zwei BOMBEN
	ME._FORCE = 0.65 + random(0.2);
	ENT_PLAYLOOP( ME,jetwav,800);
}
function 3000_boss()
{
	planesnr+=1;
	temp.x = 400;
	temp.y = 0;
	temp.z = 0;
	tempvec.pan = random(360);
	vec_rotate(temp, tempvec);
	me = ent_create(ufoboss, temp, flug );
	BOSS = ME;
	me.scale_x=1; me.scale_y=1; me.scale_z=1;// Gre der Kaschine sicherstellen
	wait(1);// zeit geben, die Entity zu erstellen
	MY.TRANSPARENT = OFF;
	feuertest();// schiessen, wenn PLAYER im Fadenkreuz ist.
	ME.SHOOTVERT1 = 1;// bei thundblt, schiest unterh. der Tragfl.
	//ME.SHOOTVERT2 = 255;
	//MY.BOMBVERT = 144;// von hier wird die BOMBE gestartet
	ME._HEALTH = 500;// mod. Schwierigkeit: Leicht, mittel, schwer 
	ME._TYPE = _TYPE_ACTOR;
	ME.SHOOTFREQ=2;// schnelles MG
	ME.TRANSPARENT = OFF;
	//maxbomb = 2;// Soviel RAKETEN sind im Spiel
	//bombwait=100;//wartezeit zwischen zwei BOMBEN
	ME._FORCE = 0.250;
	ENT_PLAYLOOP( ME,ufobosswav,800);
 	3000_ufoanim();
}

// Zeppelin wird anders bewegt als Flugzeuge
function zeppelin_run()
{	
	var turnTimeOut;
	var richtung=1;
	turnTimeOut = total_ticks + 100 + random(200);
	while(me){
		planemove();
		me.pan = ang(camera.pan-180);
		force = my._force;
		my.z=0;
		actor_move();
		my.z=0;

//db1=total_ticks;	
//db2=turntimeout;

		// Zeit fr eine neue Bewegungsaktion:
		// - fhrt eine Wende durch, wenn der ZEPPELIN nahe beim PLAYER ist
		// - wenn der ZEPPELIN zu weit vom PLAYER entfert ist, dann neue Position
		if (total_ticks >= turnTimeOut) {
			if (vec_length(my.x)>=600){
				my.x = 350;
				my.y = 0;
				my.z = 0;
				temp = random(80)-40;
				if (random(1)>0.5){// -30..30
					richtung=-1;
					my.tilt=180;
				} else {// -150..-180 && 150..180
					if(temp<0){temp-=140;} else {temp+=140;}
					richtung=1;
					my.tilt=0;
				}			
				tempvec.pan = ang(temp-camera.pan);
//db1=ang(tempvec.pan-camera.pan);
				tempvec.tilt = 0;
				tempvec.roll = 0;
				vec_rotate(my.x, tempvec);
				turnTimeOut = total_ticks + 100 + random(200);
			} else {	
				if (richtung==1) {
					if (my.tilt < 180) {
						my.tilt += 0.25;
					} else {
						richtung = -1;
						turnTimeOut = total_ticks + 100 + random(200);
					}
				} else {
					if (my.tilt > 0) {
						my.tilt -= 0.25;
					} else {
						richtung = 1;
						turnTimeOut = total_ticks + 100 + random(200);
					}
				}
			}
		}		
		if (PLAYER==NULL || playerAnz==0) {alphafade();}
		wait(1);
	}
}

function 1916_boss()
{
	planesnr+=1;
	temp.x=0;temp.y=400;temp.z=0;
	tempvec.pan = ang(random(360));
	tempvec.tilt = 0;
	tempvec.roll = 0;
	vec_rotate(temp, tempvec);
	me = ent_create(zeppelin, temp, zeppelin_run );
//	planemove();
//	startpos();
//	flug();
	BOSS = ME;
	me.scale_x=1; me.scale_y=1; me.scale_z=1;// Gre der Kaschine sicherstellen
	wait(1);// zeit geben, die Entity zu erstellen
	MY.TRANSPARENT = OFF;
	//1942_bossduesen();// Dsenstrahlen
	feuertest();// schiessen, wenn PLAYER im Fadenkreuz ist.
	ME.SHOOTVERT1 = 281;// bei thundblt, schiest unterh. der Tragfl.
	ME.SHOOTVERT2 = 380;
	MY.BOMBVERT = 325;// von hier wird die BOMBE gestartet
	ME._HEALTH = 500;// mod. Schwierigkeit: Leicht, mittel, schwer 
	ME._TYPE = _TYPE_ACTOR;
	ME.SHOOTFREQ=3;// norm. MG
	ME.TRANSPARENT = OFF;
	maxbomb = 2;// Soviel RAKETEN sind im Spiel
	bombwait=100;//wartezeit zwischen zwei BOMBEN
	ME._FORCE = 0.4 + random(0.125);
	ENT_PLAYLOOP( ME,ddwav,600);
}

function 1942_bossduesen()
{
	while(ME){
		// zwei Dsenstrahlen
		vec_for_vertex(temp, my, 168);
		tempvec.x=-5;tempvec.y=0;tempvec.z=0;
		vec_rotate(tempvec, my.pan); 
		effect(bombenstrahl,1,temp,tempvec);
		vec_for_vertex(temp, my, 230);
		tempvec.x=-5;tempvec.y=0;tempvec.z=0;
		vec_rotate(tempvec, my.pan); 
		effect(bombenstrahl,1,temp,tempvec);
		wait(1);
	}
}

function 1984_bossduesen()
{
	while(ME){
		// zwei Dsenstrahlen
		vec_for_vertex(temp, my, 292);
		tempvec.x=-5;tempvec.y=0;tempvec.z=0;
		vec_rotate(tempvec, my.pan); 
		effect(bombenstrahl,1,temp,tempvec);
		vec_for_vertex(temp, my, 11);
		tempvec.x=-5;tempvec.y=0;tempvec.z=0;
		vec_rotate(tempvec, my.pan); 
		effect(bombenstrahl,1,temp,tempvec);
		wait(1);
	}
}
function 1984_mig29duesen()
{
	while(ME){
		// zwei Dsenstrahlen
		vec_for_vertex(temp, my, 386);
		tempvec.x=-3;tempvec.y=0;tempvec.z=0;
		vec_rotate(tempvec, my.pan); 
		effect(bombenstrahl,1,temp,tempvec);
		vec_for_vertex(temp, my, 207);
		tempvec.x=-3;tempvec.y=0;tempvec.z=0;
		vec_rotate(tempvec, my.pan); 
		effect(bombenstrahl,1,temp,tempvec);
		wait(1);
	}
}
function 1970_neueMaschine()
{
	temp.x = 350;
	temp.y = 0;
	temp.z = 0;
	tempvec.pan = random(360);
	vec_rotate(temp, tempvec);
	planesnr+=1;	// Anzahl feindlicher Flugzeuge im Spiel
	me = ent_create(hub, temp, flug );
	wait(1);// zeit geben, die Entity zu erstellen
	feuertest();// schiessen/bomben, wenn PLAYER im Fadenkreuz ist.
	ME.SHOOTVERT1 = 114;// bei B52h, schiest durch Prop.
	ME._HEALTH = 20;// mod. Schwierigkeit: Leicht 60, mittel 100, schwer 140 
	ME._TYPE = _TYPE_ACTOR;
	ME._FORCE = 0.9 + random(0.2);// ist 1/2 bis 2/3 mal so schnell wie PLAYER
	ME.TRANSPARENT = OFF;
	ENT_PLAYLOOP( ME,hubwav,675);
	me.scale_x=1; me.scale_y=1; me.scale_z=1;	// Gre der Kaschine sicherstellen
	ent_create(hubprop, nullvector, attach_prop_entity );
	//wait(1);// zeit geben, die Entity zu erstellen	
	ent_create(hubproph, nullvector, attach_prop_entity );
	//wait(1);// zeit geben, die Entity zu erstellen	
	//attach_prop_entity();// Bei dieser Maschine gibt es eine Propeller-Animation
}

function 1984_neueMaschine()
{
	temp.x = 350;
	temp.y = 0;
	temp.z = 0;
	tempvec.pan = random(360);
	vec_rotate(temp, tempvec);
	planesnr+=1;	// Anzahl feindlicher Flugzeuge im Spiel
	me = ent_create(mig29, temp, flug );
	wait(1);// zeit geben, die Entity zu erstellen
	feuertest();// schiessen/bomben, wenn PLAYER im Fadenkreuz ist.
	ME.SHOOTVERT1 = 280;// bei B52h, schiest durch Prop.
	ME._HEALTH = 20;// mod. Schwierigkeit: Leicht 60, mittel 100, schwer 140 
	ME._TYPE = _TYPE_ACTOR;
	ME._FORCE = 1 + random(0.1);// ist 1/2 bis 2/3 mal so schnell wie PLAYER
	ME.TRANSPARENT = OFF;
	ENT_PLAYLOOP( ME,jetwav,700);
	me.scale_x=1; me.scale_y=1; me.scale_z=1;	// Gre der Kaschine sicherstellen
 	1984_mig29duesen();
}

function 3000_neueMaschine()
{
	temp.x = 350;
	temp.y = 0;
	temp.z = 0;
	tempvec.pan = random(360);
	vec_rotate(temp, tempvec);
	planesnr+=1;	// Anzahl feindlicher Flugzeuge im Spiel
	me = ent_create(ufo, temp, flug );
	wait(1);// zeit geben, die Entity zu erstellen
	feuertest();// schiessen/bomben, wenn PLAYER im Fadenkreuz ist.
	ME.SHOOTVERT1 = 42;// bei B52h, schiest durch Prop.
	ME._HEALTH = 20;// mod. Schwierigkeit: Leicht 60, mittel 100, schwer 140 
	ME._TYPE = _TYPE_ACTOR;
	ME._FORCE = 0.001;// ist 1/2 bis 2/3 mal so schnell wie PLAYER
	ME.TRANSPARENT = OFF;
	ENT_PLAYLOOP( ME,ufowav,650);
	me.scale_x=1; me.scale_y=1; me.scale_z=1;	// Gre der Kaschine sicherstellen
 	3000_ufoanim();
	// Flugverhalten des UFOS
//	while(me){
//	}
}

function 1916_neueMaschine()
{
	temp.x = 350;
	temp.y = 0;
	temp.z = 0;
	tempvec.pan = random(360);
	vec_rotate(temp, tempvec);
	planesnr+=1;	// Anzahl feindlicher Flugzeuge im Spiel
	me = ent_create(dd, temp, flug );
	wait(1);// zeit geben, die Entity zu erstellen
	feuertest();// schiessen/bomben, wenn PLAYER im Fadenkreuz ist.
	ME.SHOOTVERT1 = 80;// bei B52h, schiest durch Prop.
	ME._HEALTH = 20;// mod. Schwierigkeit: Leicht 60, mittel 100, schwer 140 
	ME._TYPE = _TYPE_ACTOR;
	ME._FORCE = 0.6 + random(0.2);// ist 1/2 bis 2/3 mal so schnell wie PLAYER
	ME.TRANSPARENT = OFF;
	ENT_PLAYLOOP( ME,ddwav,700);
	me.scale_x=1; me.scale_y=1; me.scale_z=1;	// Gre der Kaschine sicherstellen
	ent_create(ddprop, nullvector, attach_prop_entity );
	wait(1);// zeit geben, die Entity zu erstellen	
	//attach_prop_entity();// Bei dieser Maschine gibt es eine Propeller-Animation
}

function 1942_neueMaschine()
{
	temp.x = 300;
	temp.y = 0;
	temp.z = 0;
	tempvec.pan = random(360);
	vec_rotate(temp, tempvec);
	planesnr+=1;	// Anzahl feindlicher Flugzeuge im Spiel
	me = ent_create(b52h, temp, flug );
	wait(1);// zeit geben, die Entity zu erstellen
	prop_rot();// Bei dieser Maschine gibt es eine Propeller-Animation
	feuertest();// schiessen/bomben, wenn PLAYER im Fadenkreuz ist.
	ME.SHOOTVERT1 = 505;// bei B52h, schiest durch Prop.
	ME._HEALTH = 20;// mod. Schwierigkeit: Leicht 60, mittel 100, schwer 140 
	ME._TYPE = _TYPE_ACTOR;
	ME._FORCE = 0.8 + random(0.2);// ist 1/2 bis 2/3 mal so schnell wie PLAYER
	ME.TRANSPARENT = OFF;
	ENT_PLAYLOOP( ME,propwav,400);
	me.scale_x=1; me.scale_y=1; me.scale_z=1;	// Gre der Kaschine sicherstellen
}


/*
	Die staffel bekommt einen Fhrer mit den Atributen: visible & passable
	der auf dem path entlang flieg. Die anderen Maschinen folgen ihm.
*/	



var staffelpos[10] = 300,0,  400,250, 400,-250, 500,-500, 500,500;
function 1942_neueStaffel()
{
	var staffelrot[3];
	var sndhandle;
	var anzahl = 0;
	staffelrot.pan = random(360);

	sndhandle = snd_play(staffel, 50, 0);
	snd_TUNE (sndHandle, 0, 200, 0);

	while(anzahl<5){
		temp.x = staffelpos[pilotnr*2];
		temp.y = staffelpos[pilotnr*2+1];
		temp.z = 0;
		vec_rotate(temp, staffelrot);
		me = ent_create(b52h, temp, flug );
		pilotnr+=1;	// Nummer des Piloten der Staffel
		anzahl+=1;
		ME.STAFFELPILOT = pilotnr;	
		wait(1);// zeit geben, die Entity zu erstellen
		prop_rot();// Bei dieser Maschine gibt es eine Propeller-Animation
		feuertest();// schiessen, wenn PLAYER im Fadenkreuz ist.
		ME.SHOOTVERT1 = 505;// bei B52h, schiest durch Prop.
		ME._HEALTH = 20;// mod. Schwierigkeit: Leicht, mittel, schwer 
		ME._TYPE = _TYPE_ACTOR;
		ME._FORCE = 0.8 + random(0.2);
		ME.TRANSPARENT = OFF;
		ENT_PLAYLOOP( ME,propwav,400);
		me.scale_x=1; me.scale_y=1; me.scale_z=1;	// Gre der Kaschine sicherstellen
		planesnr+=1;// Anzahl feindlicher Flugzeuge im Spiel
		wait(60+random(60));
	}
	squad=ON;// Staffel komplett
}
function 3000_neueStaffel()
{
	var staffelrot[3];
	var sndhandle;
	var anzahl = 0;
	staffelrot.pan = 0;

	sndhandle = snd_play(staffel, 50, 0);
	snd_TUNE (sndHandle, 0, 200, 0);

	while(anzahl<5){
		temp.x = 150;
		temp.y = 0;
		temp.z = 0;
		vec_rotate(temp, staffelrot);
		staffelrot+=60;
		me = ent_create(ufo, temp, flug );
		pilotnr+=1;	// Nummer des Piloten der Staffel
		anzahl+=1;
		ME.STAFFELPILOT = pilotnr;	
		wait(1);// zeit geben, die Entity zu erstellen
		prop_rot();// Bei dieser Maschine gibt es eine Propeller-Animation
		feuertest();// schiessen, wenn PLAYER im Fadenkreuz ist.
		ME.SHOOTVERT1 = 42;// bei B52h, schiest durch Prop.
		ME._HEALTH = 20;// mod. Schwierigkeit: Leicht, mittel, schwer 
		ME._TYPE = _TYPE_ACTOR;
		ME._FORCE = 0.001;
		ME.TRANSPARENT = OFF;
		ENT_PLAYLOOP( ME,ufowav,650);
		me.scale_x=1; me.scale_y=1; me.scale_z=1;	// Gre der Kaschine sicherstellen
		planesnr+=1;// Anzahl feindlicher Flugzeuge im Spiel
 		3000_ufoanim();
		wait(1+random(2));
	}
	squad=ON;// Staffel komplett
}
function 1916_neueStaffel()
{
	var staffelrot[3];
	var sndhandle;
	var anzahl = 0;
	staffelrot.pan = random(360);

	sndhandle = snd_play(staffel, 50, 0);
	snd_TUNE (sndHandle, 0, 200, 0);

	while(anzahl<5){
		temp.x = staffelpos[pilotnr*2];
		temp.y = staffelpos[pilotnr*2+1];
		temp.z = 0;
		vec_rotate(temp, staffelrot);
		me = ent_create(dd, temp, flug );
		pilotnr+=1;	// Nummer des Piloten der Staffel
		anzahl+=1;
		ME.STAFFELPILOT = pilotnr;	
		wait(1);// zeit geben, die Entity zu erstellen
		feuertest();// schiessen, wenn PLAYER im Fadenkreuz ist.
		ME.SHOOTVERT1 = 80;// bei B52h, schiest durch Prop.
		ME._HEALTH = 20;// mod. Schwierigkeit: Leicht 60, mittel 100, schwer 140 
		ME._TYPE = _TYPE_ACTOR;
		ME._FORCE = 0.6 + random(0.2);// ist 1/2 bis 2/3 mal so schnell wie PLAYER
		ME.TRANSPARENT = OFF;
		ENT_PLAYLOOP( ME,ddwav,600);
		me.scale_x=1; me.scale_y=1; me.scale_z=1;	// Gre der Kaschine sicherstellen
		ent_create(ddprop, nullvector, attach_prop_entity );
		planesnr+=1;// Anzahl feindlicher Flugzeuge im Spiel
		wait(60+random(60));
	}
	squad=ON;// Staffel komplett
}

function 1970_neueStaffel()
{
	var staffelrot[3];
	var sndhandle;
	var anzahl = 0;
	staffelrot.pan = random(360);

	sndhandle = snd_play(staffel, 50, 0);
	snd_TUNE (sndHandle, 0, 200, 0);


	while(anzahl<5){
		temp.x = staffelpos[pilotnr*2];
		temp.y = staffelpos[pilotnr*2+1];
		temp.z = 0;
		vec_rotate(temp, staffelrot);
		me = ent_create(hub, temp, flug );
		pilotnr+=1;	// Nummer des Piloten der Staffel
		anzahl+=1;// wirklich nur 5 Maschinen erschaffen, auch wenn zwischenzeitlich welche abgeschossen werden
		ME.STAFFELPILOT = pilotnr;	
		wait(1);// zeit geben, die Entity zu erstellen
		feuertest();// schiessen, wenn PLAYER im Fadenkreuz ist.
		ME.SHOOTVERT1 = 114;// bei B52h, schiest durch Prop.
		ME._HEALTH = 20;// mod. Schwierigkeit: Leicht 60, mittel 100, schwer 140 
		ME._TYPE = _TYPE_ACTOR;
		ME._FORCE = 0.9 + random(0.2);// ist 1/2 bis 2/3 mal so schnell wie PLAYER
		ME.TRANSPARENT = OFF;
		ENT_PLAYLOOP( ME,ddwav,675);
		me.scale_x=1; me.scale_y=1; me.scale_z=1;	// Gre der Kaschine sicherstellen
		ent_create(hubprop, nullvector, attach_prop_entity );
		//wait(1);// zeit geben, die Entity zu erstellen	
		ent_create(hubproph, nullvector, attach_prop_entity );
		//wait(1);// zeit geben, die Entity zu erstellen	
		planesnr+=1;// Anzahl feindlicher Flugzeuge im Spiel
		wait(60+random(60));
	}
	squad=ON;// Staffel komplett
}

function 1984_neueStaffel()
{
	var staffelrot[3];
	var sndhandle;
	var anzahl = 0;
	staffelrot.pan = random(360);

	sndhandle = snd_play(staffel, 50, 0);
	snd_TUNE (sndHandle, 0, 200, 0);

	while(anzahl<5){
		temp.x = staffelpos[pilotnr*2];
		temp.y = staffelpos[pilotnr*2+1];
		temp.z = 0;
		vec_rotate(temp, staffelrot);
		me = ent_create(mig29, temp, flug );
		pilotnr+=1;	// Nummer des Piloten der Staffel
		anzahl+=1;// wirklich nur 5 Maschinen erschaffen, auch wenn zwischenzeitlich welche abgeschossen werden
		ME.STAFFELPILOT = pilotnr;	
		wait(1);// zeit geben, die Entity zu erstellen
		feuertest();// schiessen, wenn PLAYER im Fadenkreuz ist.
		ME.SHOOTVERT1 = 280;// bei B52h, schiest durch Prop.
		ME._HEALTH = 20;// mod. Schwierigkeit: Leicht 60, mittel 100, schwer 140 
		ME._TYPE = _TYPE_ACTOR;
		ME._FORCE = 1 + random(0.1);// ist 1/2 bis 2/3 mal so schnell wie PLAYER
		ME.TRANSPARENT = OFF;
		ENT_PLAYLOOP( ME,jetwav,700);
		me.scale_x=1; me.scale_y=1; me.scale_z=1;	// Gre der Kaschine sicherstellen
		1984_mig29duesen();
		planesnr+=1;// Anzahl feindlicher Flugzeuge im Spiel
		wait(60+random(60));
	}
	squad=ON;// Staffel komplett
}

function player_init()
{
	var sndhandle;
	bugcheck();

	me = ent_create(f16, nullvector, playertop );
	ME.ENABLE_IMPACT = ON; 
	ME.ENABLE_ENTITY = ON;
	ME.EVENT = PLAYER_EVENT;
	wait(1);
	alphafadein();


	ME.SHOOTVERT1 = 263;
//	ME.SHOOTVERT2 = 382;

	//			ME.SHOOTVERT1 = 53;
	//			ME.SHOOTVERT2 = 481; 

	ME._HEALTH = 100;
	ME._TYPE = _TYPE_PLAYER;
	me.scale_x=1.005; me.scale_y=1.005; me.scale_z=1.005;
	me._SPEED=2.25;
	me._ASPEED=2;
	ME.SHOOTFREQ=2;// schnelles MG
	if(playerNr){
		life_set(lifes2, my._health);
	} else {
		life_set(lifes1, my._health);
	}
	wait(1);

	nextAD();

	sndhandle = snd_play(levelstart, 90, 0);
	//snd_TUNE (sndHandle, 0, 200, 0);	
}

function punkte500()
{
	var sndhandle;
	score_add(500);
	sndhandle = snd_play(bonus, 90, 0);
	snd_TUNE (sndHandle, 0, 200, 0);

	me = ent_create(pkt500, pktvec, null );
	MY.FACING = ON;
	MY.PASSABLE = ON;

	my.EXTRAZEIT = 100;// Lebenszeit
	while(ME){
//db9=my.extrazeit;
		planemove();
		MY.EXTRAZEIT-=time*4;
		if (MY.EXTRAZEIT<=0){alphafade();}
		wait(1);
	}	
}

entity* extra_ent;
function extra()
{	
	// Falls die kollisionsroutine versagt..
	var isBug;
	var BugCnt;

	EXTRA_ENT = ME;

	while(dummy_ent){
		me.pan = ang(camera.pan-90);
		me.roll = ang(my.roll + 0.2);
		my.x = dummy_ent.x;
		my.y = dummy_ent.y;
		// Kollisonbei EXTRAS klappt machmal nicht, fehler ausbgeln.. 
		if(vec_length(my.x)<=35){ isBug=1; }
		if(isBug){BugCnt+=1;}
		if(BugCnt>=50){
			//breakpoint;
			BugSim=0;
			YOU = dummy_ent;
			ME = PLAYER;
			player_event();
			wait(1);// Schleife wird jetzt beendet 	
		}	
		wait(1);
	}
	ME = EXTRA_ENT;
	proc_kill(1);
	wait(1);
	vec_set(pktvec,me.pos);
	ent_remove(me);
	punkte500();
}
/*
function bugrun()
{
	printi("BUG AKTIV",8);
	bugsim=1;
}
on_b=bugrun;	
*/
// 1. Falschirmjger bei komplett vernichteter Staffel
// 2. Zweite Wumme bei PUNKTESTAND X+ZUFALL
// 3. Gesundheit bei PUNKTESTAND X+ZUFALL
function extra_init(extratype)
{
	temp.x=600;temp.y=0;temp.z=0;
	me = ent_create(dummy, temp, null );
	
//	wait(1);
	me.invisible = on;
	ME.ENABLE_IMPACT = ON; 
	ME.ENABLE_ENTITY = ON;
	ME._TYPE = _TYPE_EXTRA;
	ME.EXTRA = EXTRATYPE;//_EXTRA_WUMME;
//	randomize();
	my._FORCE = 0.2+random(0.2);
	startpos();
	flug();
	dummy_ent = me;

	if (EXTRATYPE==_EXTRA_PILOT){
		me = ent_create(pilot, temp, extra );
	}
	if (EXTRATYPE==_EXTRA_AMMO){
		me = ent_create(ammo, temp, extra );
	}
	if (EXTRATYPE==_EXTRA_WUMME){
		me = ent_create(mg, temp, extra );
	}
	if (EXTRATYPE==_EXTRA_GAS){
		me = ent_create(gas, temp, extra );
	}

	me.passable = on;	
	temp_ent = ent_create(fallschirm, temp, attach_entity);
	temp_ent.passable = on;
	temp_ent.unlit = on; 
	temp_ent.ambient = 150;
}

var stophc;
function hiscoredisp()
{
	stophc = 1;
	var hcset;
	var displ;
	while(stophc){
		// HISCORES AUF- UND -ABBAUEN
		if (running==0){
			if (hcset==0){
				if (displ==0) {open_hiscore();}	
				if (displ==1) {displ_points();} 
				if (displ==2) {displ_ctrl();}
				displ +=1;
				if (displ==3) {displ=0;}
				wait(1); 
				hcset=1;
			} else { 
				clearslow(); 
				wait(1); 
				hcset=0; 
			}
		}
		waitt(40);
	}
}

function mainscreen()
{
	var sndhandle;	
	score_txt.visible = on;	
	score_pan.visible = on;
	game_txt.visible = off;

	titelscreen.visible = ON;

	// Falls ein HISCORE eingetragen werden mu
	result = test_score(SCORE1);
	if (result){	
		namen_eingeben(0);
		wait(1);
		while(running){wait(1);}
		ScoreTop10(SCORE1);
	}
	result = test_score(SCORE2);
	if (result){	
		namen_eingeben(1);
		wait(1);
		while(running){wait(1);}
		ScoreTop10(SCORE2);
	}
		
	// blendet von Zeit zu Zeit den HISCORE ein und aus
	hiscoredisp();

	playerLevel[0]=1916;
	playerLevel[1]=1916;
	// Warteschleife
	while(1){
		// Leveleinstellung per F-tasten, nur zum Testen
		if(key_f5){playerLevel[0]=1916;playerLevel[1]=1916;}
		if(key_f6){playerLevel[0]=1942;playerLevel[1]=1942;}
		if(key_f7){playerLevel[0]=1970;playerLevel[1]=1970;}
		if(key_f8){playerLevel[0]=1984;playerLevel[1]=1984;}
		if(key_f9){playerLevel[0]=3000;playerLevel[1]=3000;}

		if (key_1 || joy_1){
			playerAnz=1;
			playerNr=0;
			break;
		}	
		if (key_2){
			playerAnz=2;
			playerNr=0;
			break;
		}	
		if (snd_playing (sndhandle) == 0 && int(random(2000))==1){
			sndhandle = snd_play(intro, 70, 0);
			//snd_TUNE (sndHandle, 0, 190, 0);
		}
		wait(1);
	}


	loadLevel(playerLevel[0]);
	
// freeze the game
	freeze_mode = 1;

	stophc=0;// Signal, das HISCORE GELSCHT WERDEN
	sleep(1);// Levellader zeit geben..
	load_status();
	while(running){waitt(1);}
	clear();// HISCORES etc.
	snd_stop(sndhandle); 

	if(gfxloaded==0){
		preload1916();
		preload1942();
		preload1970();
		preload1984();
		preload3000();
		preload();
		//gfxloaded=1;
		while(gfxloaded==0){wait(1);}
	}

	titelscreen.visible=off;
	bmap_purge(titelmap);	
//	titelscreen.transparent = OFF;
	freeze_mode = 0;
	MCP();
}
// Master-Control-Program (MCP)
// Spielsteuerung
function MCP()
{		
	//game_running = playerAnz;// Fr ESCAPE-Taste
	//bombwait=400;// Zeitraum zwischen zwei Bombem
	LevelEnde=0;
	var sndhandle;
	var MaxSolo=2;	// MAximale Anzahl Soloflieger

	lifes1=5;
	lifes2=5;

	score1=0;
	score2=0;

//	vec_set(ticks,nullvector);// zur Zeitsteuerung
	ticks[0]=0;
	ticks[1]=0;

	var ExtrasTimeStop[2];// Stopuhr fr die Vergabe von Extras
	ExtrasTimeStop[0]=75+random(25);
	ExtrasTimeStop[1]=75+random(25);

	var PilotTimeStop[2];
	PilotTimeStop[0]=random(5);
	PilotTimeStop[1]=random(5);

	var StaffelTimeStop[2];
	StaffelTimeStop[0]=50+random(50);
	StaffelTimeStop[1]=50+random(50);

	var LevelTimeStop=500;// Zeitlnge des Levels
	LevelTimeStop+=random(250);
//	leveltimestop/=100;

//db2=leveltimestop;

	var ExtraCnt[2];
	ExtraCnt[0]=0;
	ExtraCnt[1]=0;

	while(playerAnz) {
		while(paused){wait(1);}// ticks nicht weiterzhlen
		ticks[playerNr]+=(time/10);

//		db1=ticks[playerNr];
//		db3=leveltimestop;

		// neues LEVEL?
		if (LevelEnde==1){ 
			waitt(10);
			clear();
			game_txt.visible = off;
			if(blende_ent){
				sndhandle = snd_play(levelend, 70, 0);
				snd_TUNE (sndHandle, 0, 190, 0);
				blende_ent.z = 365;
				blende_ent.invisible = off;
				blende_ent.transparent = off;

				while(blende_ent.z > 200){
					blende_ent.pan = ang(camera.pan-90);
					blende_ent.z -= time*12;
					wait(1);
				}
				levelscreen.visible = ON;
				blende_ent.invisible = on;
				snd_STOP (sndhandle);

				// nchstes Level fr PLAYER 1 oder 2
				nextLevel();
				freeze_mode=1;
				sleep(1);
				freeze_mode=0;
				while(blende_ent==0){wait(1);}// Warte, bis ENT vollstndig geladen ist
				levelscreen.visible=OFF;
				bmap_purge(levelmap);
				blende_ent.z = 200;
				blende_ent.invisible = off;
				blende_ent.transparent = off;

				ticks[playerNr]=0;
				ExtrasTimeStop[playerNr]=75+random(25);
				PilotTimeStop[playerNr]=5+random(10);
				StaffelTimeStop[playerNr]=50+random(50);
				//ExtraCnt[playerNr]=0;
				PilotNr=0;
				PlanesNr=0;
				BombenNr=0;
				
				while(blende_ent.z < 365){
					blende_ent.pan = ang(camera.pan-90);
					blende_ent.z += time*20;
					wait(1);
				}
				blende_ent.invisible = ON;

			}//if(blende_ent)
			LevelEnde=0;
		//	db6=player;db7=levelende;
		}// if (LevelEnde==1)
		

		//ggf. PLAYER ERSCHAFFEN
		if (Levelende==0 && PLAYER==NULL && planesnr==0 && BombenNr==0) {
			// GAME-OVER testen fr beide PLAYER
			if (lifes1==0){
				lifes1-=1;
				playerAnz-=1;
				game_over(0);
				waitt(30);
				clear();
				//game_running-=1;
			}
			if (lifes2==0){
				lifes2-=1;
				playerAnz-=1;
				game_over(1);
				waitt(30);
				clear();
				//game_running-=1;
			}

			// PLAYER nur erschaffen, wenn er im richtigen LEVEL ist
			if (LevelEnde==0 && playerAnz){
				if(levelNr != playerLevel[PlayerNr]){
					clear();
					levelscreen.visible = ON;
					loadLevel(playerLevel[PlayerNr]);
					levelNr = playerLevel[playerNr];
					freeze_mode=1;
					sleep(1);
					freeze_mode=0;
					levelscreen.visible = OFF;
				} else {
					player_init();
					wait(1);
					get_ready(playerNr);
				}
			}

		}	

		/* EXTRAS werden vergeben, wenn:
			- allgemein: Extras-Zeitzhler Wert+Zufall berschritten hat
			- Extra-Zhler auf ein bestimmtes Extra zeigt	
		*/
		if(PLAYER && dummy_ent==null && ticks[playerNr] >= ExtrasTimeStop[playerNr]){
			ExtrasTimeStop[playerNr]=ticks[playerNr] + 75 + random(25);//neue Stopzeit setzen 
//db2=extrastimestop;	
			if (PLAYER._HEALTH<=40){// gib den PLAYER Gesundheit
				if(ExtraCnt[playerNr]==1){ExtraCnt[playerNr]=0;}
				if(ExtraCnt[playerNr]==3){ExtraCnt[playerNr]=2;}
				if(ExtraCnt[playerNr]==5){ExtraCnt[playerNr]=4;}
			}
			if (ExtraCnt[playerNr]==5){extra_init(_EXTRA_PILOT);}
			if (ExtraCnt[playerNr]==3){extra_init(_EXTRA_WUMME);}		
			if (ExtraCnt[playerNr]==1){extra_init(_EXTRA_GAS);}
			if (ExtraCnt[playerNr]==0 || ExtraCnt[playerNr]==2 || 
				 ExtraCnt[playerNr]==4){extra_init(_EXTRA_AMMO);}	
			ExtraCnt[playerNr]+=1;
			if(ExtraCnt[playerNr]==6){ExtraCnt[playerNr]=0;}
		}	
		/* Soloflieger, Staffeln und Engegner tauchen auf, wenn:
			STAFFEL:	
			- Eine Staffel komplett vernichtet wurde 
			- Zeitlimit berschritten wurde
			- die Levelzeit noch nicht abgelaufen ist
			SOLLOFLIEGER:
			- max. 2 Soloflieger im Spiel sind
			- das Zeitlimit berschritten wurde (sehr kurz!)
			BOSS:
			- wenn die Levelzeit abgelaufen ist
			- <=3 Flieger im Spiel sind  	
		*/

		// SOLOFLIEGER
		if (LevelEnde==0 && PLAYER && PilotNr==0 && PlanesNr<=MaxSolo && Ticks[playerNr] >= PilotTimeStop[playerNr] && Ticks[playerNr] < StaffelTimeStop[playerNr]) {
			PilotTimeStop[playerNr] = ticks[playerNr]+1+random(5);		
			fliegfnk();
			wait(1);
		}


//db2=staffeltimestop[playerNr];
//db4=pilotnr;
		if(LevelEnde==0 && PLAYER && PlanesNr == 0 && Ticks[playerNr] >= StaffelTimeStop[playerNr] && Ticks[playerNr] < LevelTimeStop){ 
			StaffelTimeStop[playerNr] = ticks[playerNr]+100+random(50);
			staffnk();
			wait(1);

		}

//db2=boss;
//leveltimestop=0;

		if(Levelende==0 && BOSS==NULL && Ticks[PlayerNr] >= LevelTimeStop && PlanesNr<=2){
			StaffelTimeStop[playerNr]=999999;// Soloflieger wartet nicht mehr auf Staffeln
			bossfnk();		
			wait(1);
		}

		/*
			SPIELENDE ist:
			- wenn die Levelzeit abgelaufen ist
			- ==0 Maschinen im Spiel sind 
		*/

//		db8=planesnr;
//		db9=pilotnr;
		wait(1);
	}
 	clear();
	waitt(10);// ausblenden lassen
	mainscreen();
}

function abord()
{levelende=1;}
on_a = abord;

function attach_prop_entity()
{
   my.passable = on;
   while(you) // prevent empty synoym error if parent entity was removed
   {
      if(your.shadow == on) { my.shadow = on; }

      vec_set(my.x,you.x);
      vec_set(my.pan,you.pan);

      // increment _ANIMDIST by elapsed time
      my._ANIMDIST += 50*TIME; // replace 50 with engine speed in game
      while(my._ANIMDIST > 100)
      {
          my._ANIMDIST -= 100;
      }
      ent_frame("Frame",my._ANIMDIST);

      wait(1);
   }
   remove(my);
}


function 3000_ufoanim()
{
	var invisibleTimeOut=10;
	invisibleTimeOut+=total_ticks + random(25);
	var alphaset;
	if(ME==BOSS){BOSS.TILT=340;}
	while(me){
//db3=total_ticks;
//db5=invisibletimeout;
	//	if(ME==BOSS){temp=5;} else {temp=10;}
		my._ANIMDIST += temp*TIME; // replace 50 with engine speed in game
    	while(my._ANIMDIST > 100)
      {
          my._ANIMDIST -= 100;
      }
      ent_frame("Frame",my._ANIMDIST);

		
		if(total_ticks>=invisibleTimeOut){
	 		invisibleTimeOut=total_ticks + 10 + random(40);
			// neu positionieren
			temp.x = 150 + random(200);
			temp.y = 0;
			temp.z = 0;
			tempvec.pan = random(360);
			tempvec.tilt = 0;
			tempvec.roll = 0;
			vec_rotate(temp, tempvec);
			vec_set(my.x, temp);

			if(alphaset){
				my.transparent=OFF;
				alphaset=OFF;
			} else {
				my.alpha=10+random(50);
				my.transparent=on;
				alphaset=ON;	
			} else {
				if(total_ticks>=(invisibleTimeOut/2)){
		  			my.red = int(random(2))*255;
  					my.green = int(random(2))*255;
  					my.blue = int(random(2))*255; 
		   		my.lightrange = 100+random(100); // Lichtkugel von 200 Quants
				}
			}
		}
      wait(1);
   }	
}

function prop_rot()
{
	while(me)
	{
	   // increment _ANIMDIST by elapsed time
      my._ANIMDIST += 50*TIME; // replace 50 with engine speed in game
      while(my._ANIMDIST > 100)
      {
          my._ANIMDIST -= 100;
      }
      ent_frame("fly",my._ANIMDIST);

      wait(1);
	}
}


function bullet_shot()
{
	vec_scale(MY.SCALE_X,actor_scale);	// use actor_scale

	MY.ENABLE_BLOCK = ON;
	MY.ENABLE_ENTITY = ON;
	MY.ENABLE_STUCK = ON;
	MY.ENABLE_IMPACT = ON;
	MY.ENABLE_PUSH = ON;
	MY.EVENT = _fireball_event;

	MY.FACING = ON;	// in case of fireball

	MY.LIGHTRED = light_bullet.RED;
	MY.LIGHTGREEN = light_bullet.GREEN;
	MY.LIGHTBLUE = light_bullet.BLUE;
	MY.LIGHTRANGE = 40;
	MY.AMBIENT = 80;

	MY.SKILL2 = shot_speed.x;
	MY.SKILL3 = shot_speed.y;
	MY.SKILL4 = 0;//shot_speed.z;
	MY._DAMAGE = damage;
	MY._FIREMODE = fire_mode;


	MY.SKILL33 = 35;//Lebensdauer	
  	// my.near is set by the explosion
	while(MY.NEAR != ON)
	{
		wait(1); // wait at the loop beginning, to let it appear at the start position

		temp = TIME;
		if(temp > 1.5) { temp = 1.5; }	// make bullet slower on slow PCs
// MOVE moves by a distance, so multiply the speed by time.
		fireball_speed.x = MY.SKILL2 * temp;
		fireball_speed.y = MY.SKILL3 * temp;
		fireball_speed.z = 0;//MY.SKILL4 * temp;

		
//		if (int(random(10))==1){	effect(rauchspur,1,my.pos,normal);}


		vec_scale(fireball_speed,movement_scale);	// scale fireball_speed by movement_scale
 		//--move(ME,nullskill,fireball_speed);
		move_mode = ignore_you + ignore_passable + activate_trigger;
		result = ent_move(nullskill,fireball_speed);

		// Lebensdauer begrenzen
		if (MY.SKILL33 > 0) {MY.SKILL33-=1;} else {break;}
	//	db7=my.skill33;
	}
		morph BULLET_SMOKE,ME;
		MY._DIEFRAMES = EXPLO_FRAMES;
		actor_smoke();
	//db8-=1;
}

function laser_shot()
{
	vec_scale(MY.SCALE_X,actor_scale);	// use actor_scale

	MY.ENABLE_BLOCK = ON;
	MY.ENABLE_ENTITY = ON;
	MY.ENABLE_STUCK = ON;
	MY.ENABLE_IMPACT = ON;
	MY.ENABLE_PUSH = ON;
	MY.EVENT = _fireball_event;

	MY.FACING = ON;	// in case of fireball

//	MY.PASSABLE = ON;
   MY.LIGHT = ON;       // illuminate myself
	MY.LIGHTRED = 255;   // red laser
	MY.TRANSPARENT = ON;
	MY.ALPHA = 65;
	MY.BRIGHT = ON;
	MY.FLARE = ON;

//	MY.LIGHTRED = light_bullet.RED;
//	MY.LIGHTGREEN = light_bullet.GREEN;
//	MY.LIGHTBLUE = light_bullet.BLUE;
//	MY.LIGHTRANGE = 40;
//	MY.AMBIENT = 80;

	MY.SKILL2 = shot_speed.x;
	MY.SKILL3 = shot_speed.y;
	MY.SKILL4 = 0;//shot_speed.z;
	MY._DAMAGE = damage;
	MY._FIREMODE = fire_mode;


	MY.SKILL33 = 45;//Lebensdauer	
  	// my.near is set by the explosion
	while(MY.NEAR != ON)
	{
		wait(1); // wait at the loop beginning, to let it appear at the start position

		temp = TIME;
		if(temp > 1.5) { temp = 1.5; }	// make bullet slower on slow PCs
// MOVE moves by a distance, so multiply the speed by time.
		fireball_speed.x = MY.SKILL2 * temp;
		fireball_speed.y = MY.SKILL3 * temp;
		fireball_speed.z = 0;//MY.SKILL4 * temp;

		
//		if (int(random(10))==1){	effect(rauchspur,1,my.pos,normal);}


		vec_scale(fireball_speed,movement_scale);	// scale fireball_speed by movement_scale
 		//--move(ME,nullskill,fireball_speed);
		move_mode = ignore_you + ignore_passable + activate_trigger;
		result = ent_move(nullskill,fireball_speed);

		// Lebensdauer begrenzen
		if (MY.SKILL33 > 0) {MY.SKILL33-=1;} else {break;}
	//	db7=my.skill33;
	}
		morph LASER_FLASH,ME;
		MY._DIEFRAMES = EXPLO_FRAMES;
		actor_laseroff();
	//db8-=1;
}

action blende_init
{
	blende_ent = me;
//	db6=my.z;
}
/*
// Blende: zu=100 auf=360
function blende()
{
//breakpoint;
levelende=1;
return;
	var sndhandle;
	if(blende_ent){
		sndhandle = snd_play(levelend, 70, 0);
		snd_TUNE (sndHandle, 0, 190, 0);
		blende_ent.z = 365;
		blende_ent.invisible = off;
		blende_ent.transparent = off;

		while(blende_ent.z > 200){
			blende_ent.pan = ang(camera.pan-90);
			blende_ent.z -= time*12;
			wait(1);
		}
		levelscreen.visible = ON;
		blende_ent.invisible = on;
		snd_STOP (sndhandle);

		// nchstes Level fr PLAYER 1 oder 2
		nextLevel();
		freeze_mode=1;
		sleep(1);
		freeze_mode=0;

		while(blende_ent==0){wait(1);}// Warte, bis ENT vollstndig geladen ist
		levelscreen.visible=OFF;
		bmap_purge(levelmap);
		blende_ent.z = 200;
		blende_ent.invisible = off;
		blende_ent.transparent = off;
		MCP();
		while(blende_ent.z < 365){
			blende_ent.pan = ang(camera.pan-90);
			blende_ent.z += time*20;
			wait(1);
		}
		blende_ent.invisible = ON;
	}
}
*/

function loadLevel(val)
{
	levelNr = playerLevel[PlayerNr];
	maxbomb = 1;// Soviele BOMBEN beim Lvelstart
	bombwait=400;// Zeit zwischen zwei BOMBEN
	if(val==1916 || val==0){
		load_level(level1916);
		str_cpy(bombestr, bombe1916);
		bombforce = 0.555 + random(0.200);
		bossfnk = 1916_boss;
		staffnk = 1916_neueStaffel;
		fliegfnk = 1916_neueMaschine;
	} else {
		if(val==1942){
			load_level(level1942);
			str_cpy(bombestr, bombe1942);
			bombforce = 0.700 + random(0.200);
			bossfnk = 1942_Boss;
			staffnk = 1942_neueStaffel;
			fliegfnk = 1942_neueMaschine;
		} else {
			if(val==1970){
//breakpoint;
				load_level(level1970);
				str_cpy(bombestr, bombe1970);
				bombforce = 0.850 + random(0.200);
				bossfnk = 1970_Boss;
				staffnk = 1970_neueStaffel;
				fliegfnk = 1970_neueMaschine;
			} else {
				if(val==1984){
					load_level(level1984);
					str_cpy(bombestr, bombe1984);
					bombforce = 1.0 + random(0.200);
					bossfnk = 1984_Boss;
					staffnk = 1984_neueStaffel;
					fliegfnk = 1984_neueMaschine;
				} else {
					if(val==3000){
						load_level(level3000);
						str_cpy(bombestr, bombe3000);
						bombforce = 1.200 + random(0.200);
						bossfnk = 3000_boss;
						staffnk = 3000_neueStaffel;
						fliegfnk = 3000_neueMaschine;
					}
				}
			}
		}
	}
}

//on_b = blende;
function nextLevel()
{
	levelNr = playerLevel[PlayerNr];
	maxbomb = 1;// Soviele BOMBEN beim Lvelstart
	bombwait=400;// Zeit zwischen zwei BOMBEN

	if (levelNr==1916){
		level_load(level1942);
		str_cpy(bombestr, bombe1942);
		bombforce = 0.700 + random(0.200);
		levelNr=1942;
		bossfnk = 1942_Boss;
		staffnk = 1942_neueStaffel;
		fliegfnk = 1942_neueMaschine;
	} else {
		if (levelNr==1942){
			level_load(level1970);
			str_cpy(bombestr, bombe1970);
			bombforce = 0.850 + random(0.200);
			levelNr=1970;
			bossfnk = 1970_Boss;
			staffnk = 1970_neueStaffel;
			fliegfnk = 1970_neueMaschine;
		} else {
		 	if (levelNr==1970){
				level_load(level1984);
				str_cpy(bombestr, bombe1984);
				bombforce = 1.0 + random(0.200);
				levelNr=1984;
				bossfnk = 1984_Boss;
				staffnk = 1984_neueStaffel;
				fliegfnk = 1984_neueMaschine;
			} else {
				if (levelNr==1984){
					level_load(level3000);
					str_cpy(bombestr, bombe3000);
					bombforce = 1.200 + random(0.200);
					levelNr=3000;
					bossfnk = 3000_boss;
					staffnk = 3000_neueStaffel;
					fliegfnk = 3000_neueMaschine;
				} else {
					if (levelNr==3000){
						level_load(level1916);
						str_cpy(bombestr, bombe1916);
						bombforce = 0.555 + random(0.150);
						levelNr=1916;
						bossfnk = 1916_boss;
						staffnk = 1916_neueStaffel;
						fliegfnk = 1916_neueMaschine;
					} 
				}
			}
		}
	}
	playerLevel[PlayerNr] = levelNr;
}

function nextAD()
{
	if (levelNr==1916){
		level_1916();
	} else {
		if (levelNr==1942){
			level_1942();
		} else {
			if (levelNr==1970){
				level_1970();
			} else {
				if (levelNr==1984){
					level_1984();
				} else {
					if (levelNr==3000){
						level_3000();
					} 
				}
			}
		}
	}
}

function pause()
{
	if (playeranz==0){return;}// nur PAUSE im Spiel zulassen
	while(key_any==1){wait(1);}
	game_pause();
	paused=1;
	freeze_mode = 1;
	while(key_any==0){wait(1);}
	freeze_mode = 0;
	clear();
	paused=0;
}

on_pause = pause;
on_joy2 = pause;

function bugcheck()
{
	if(DUMMY_ENT){
		me = DUMMY_ENT;
		proc_kill(1);
		wait(1);
		ent_remove(me);
	}
	if(EXTRA_ENT){
		me = EXTRA_ENT;
		proc_kill(1);
		wait(1);
		ent_remove(me);
	}
}